# jobs

Testing different job scheduling and job parsing crates.

## Apalis

In addition to the below, a lot of other `apalis` examples can be found at
<https://github.com/geofmureithi/apalis/tree/main/examples>.

### PostgreSQL

Create database.

```zsh
createdb foobar
```

Run sample program.

```zsh
DATABASE_URL="postgres://${USER}:passwordifany@localhost/foobar" cargo run --release --bin using-crate-apalis-postgres
```

### SQLite

Run sample program.

```zsh
cargo run --release --bin using-crate-apalis-sqlite
```

## Clokwerk

Run sample program.

```zsh
cargo run --release --bin using-crate-clokwerk
```

The `clokwerk` repo contains only this single example
in its readme and does *not* contain any other
direct examples of use at the time of writing this.

## Cron

Run sample program.

```zsh
cargo run --release --bin using-crate-cron
```

The `cron` repo contains only this single example
in its readme and does *not* contain any other
direct examples of use at the time of writing this.

## Cron-job

Run sample program.

```zsh
cargo run --release --bin using-crate-cron-job
```

The `cron-job` repo contains a couple of other
direct examples of use in the readme, but nothing
beyond that at the time of writing this.

## Cron\_tab

Run sample programs.

```zsh
cargo run --release --bin using-crate-cron_tab-sync
```

```zsh
cargo run --release --bin using-crate-cron_tab-async
```

The `cron_tab` repo contains only these two examples
in its readme, and a copy of the two same sample programs
at <https://github.com/tuyentv96/rust-crontab/tree/master/examples>,
and does *not* contain any other direct examples of use
at the time of writing this.

## Croner

Run sample program.

```zsh
cargo run --release --bin using-crate-croner
```

Additional examples at <https://github.com/Hexagon/croner-rust/tree/main/examples>.

## Delay\_timer

Run sample programs.

```zsh
cargo run --release --bin using-crate-delay_timer-internal
```

```zsh
cargo run --release --bin using-crate-delay_timer-in-async-context
```

Additional examples at: <https://github.com/BinChengZhao/delay-timer/tree/master/examples>

## English-to-cron

Run sample program.

```zsh
cargo run --release --bin using-crate-english-to-cron
```

The `english-to-cron` repo contains only this example
in its readme, and a copy of the same sample program
at <https://github.com/kaplanelad/english-to-cron/tree/main/examples>,
and does *not* contain any other direct examples of use
at the time of writing this.

## Tokio-cron-scheduler

Run sample programs.

```zsh
cargo run --release --bin using-crate-tokio-cron-scheduler-simple_job_tokio_in_a_thread
```

```zsh
cargo run --release --bin using-crate-tokio-cron-scheduler-simple_job
```

```zsh
cargo run --release --bin using-crate-tokio-cron-scheduler-postgres_job
```

One additional example at <https://github.com/mvniekerk/tokio-cron-scheduler/tree/main/examples>
although that one (`nats_job.rs`) is not buildable for me I assume, as enabling the
nats related features did not work for me. Enabling nats features in `Cargo.toml`
for me makes Rust unable to build anything.
