//! Code from <https://github.com/Hexagon/croner-rust/blob/4da136d3363ff7d99f9bdb211f7c8c852449de6d/README.md>

use chrono::Local;
use croner::Cron;

fn main() {
    // Parse cron expression for Fridays in December
    let cron = Cron::new("0 0 0 31 12 FRI")
        // Include seconds in pattern
        .with_seconds_optional()
        // Ensure both day of month and day of week conditions are met
        .with_dom_and_dow()
        .parse()
        .expect("Couldn't parse cron string");

    let time = Local::now();

    println!("Finding the next 5 New Year's Eves on a Friday:");
    for time in cron.iter_from(time).take(5) {
        println!("{}", time);
    }
}
